from flask import Flask ,render_template, redirect, request
from func import accept_from_storage,KeyPhrase,items,recognize_parts,MyHtmlStripper

app=Flask(__name__)


main_text=''
key_phrases_list=[]
noun_list=[]

@app.route('/')
def show_text():
    global main_text,key_phrases_list
    main_text,dic=accept_from_storage()
    return render_template('speech_to_text.html',main_text=main_text,key_phrases_list=key_phrases_list,noun_list=noun_list)

@app.route('/note')
def note():
    return render_template('note.html',main_text=main_text,key_phrases_list=key_phrases_list,noun_list=noun_list)

@app.route('/accepting_text_data')
def accepting_text_data():
    return redirect('/')

@app.route('/searching_noun')
def searching_noun():
    global noun_list
    noun_list=items(main_text)
    return redirect('/note')

@app.route('/accepting_phrase_data')
def accepting_phrase_data():
    global main_text,key_phrases_list
    main_text,dic=accept_from_storage()
    for k, v in sorted(dic.items(), key=lambda x: -x[1]):
        if recognize_parts(k)=='名詞':
            key_phrases_list.append(KeyPhrase(k,v))
    return redirect('/note')

@app.route('/search_bing/<int:item_id>')
def search_bing(item_id):
    key_phrases_list[item_id].search_bing()
    return redirect('/note')

@app.route('/download_image/<int:item_id>')
def download_image(item_id):
    key_phrases_list[item_id].download_image()
    return redirect('/note')

@app.route('/delete_note')
def delete_note():
    global key_phrases_list
    key_phrases_list=[]
    return redirect('note')