from azure.storage.file import FileService
from azure.storage.file import ContentSettings
import json
from web.search import search_wiki_abstract,search_bing,download_image
from janome.tokenizer import Tokenizer
import collections
from html.parser import HTMLParser
import io
import os

t=Tokenizer()
file_service = FileService(account_name='###', account_key='###')

#storageから取得したtextとdictを返す
def accept_from_storage():
    file_service.get_file_to_path('tsuchiyashare', None, 'main.txt', 'main.txt')
    file_service.get_file_to_path('tsuchiyashare', None, 'key_phrases_dict.json', 'key_phrases_dict.json')
    with open('main.txt','r') as f:
        text=f.read()
    with open('key_phrases_dict.json','r') as f:
        dict=json.load(f)
    return text,dict

#文章中の名詞を抽出
def items(sentence):
    return collections.Counter(token.base_form for token in t.tokenize(sentence)
                          if token.part_of_speech.startswith('名詞')).most_common()

#単語の品詞を判別
def recognize_parts(word):
    token=t.tokenize(word)[0]
    return token.part_of_speech.split(',')[0]

#htmlタグの削除
class MyHtmlStripper(HTMLParser):
    def __init__(self, s):
        super().__init__()
        self.sio = io.StringIO()
        self.feed(s)

    def handle_starttag(self, tag, attrs):
        pass

    def handle_endtag(self, tag):
        pass

    def handle_data(self, data):
        self.sio.write(data)

    @property
    def value(self):
        return self.sio.getvalue()

#key_phraseのクラスを作成
class KeyPhrase:
    item_id=0
    def __init__(self,phrase,count):
        self.phrase = phrase
        self.item_id = KeyPhrase.item_id
        self.count=count
        self.abstract=search_wiki_abstract(phrase)
        self.bing=[]
        self.image_list=[]
        KeyPhrase.item_id += 1

    #bingの検索結果をhtmlタグを削除して取得
    def search_bing(self):
        self.bing=search_bing(self.phrase)
        for i in range(len(self.bing)):
            text=self.bing[i]['snippet']
            text=MyHtmlStripper(text).value
            self.bing[i]['snippet']=text
    def download_image(self):
        self.image_list=download_image(self.phrase,3)


