from SPARQLWrapper import SPARQLWrapper
import requests

#好きな文字の削除
def clear_character(text,character):
    character=character.encode('utf-8')
    text=text.encode('utf-8')
    text=text.replace(character,b'')
    text=text.decode('utf-8')
    return text



#bingの検索結果を返す
def search_bing(search_term):
    subscription_key = "###"
    assert subscription_key

    search_url = "https://api.cognitive.microsoft.com/bing/v7.0/search"
    headers = {"Ocp-Apim-Subscription-Key" : subscription_key}
    params  = {"q": search_term, "textDecorations":True, "textFormat":"HTML"}
    response = requests.get(search_url, headers=headers, params=params)
    response.raise_for_status()
    search_results = response.json()
    return search_results['webPages']['value']


#wikiのabstractを返す
def search_wiki_abstract(word):
    word=clear_character(word,' ')
    sparql = SPARQLWrapper(endpoint='http://ja.dbpedia.org/sparql', returnFormat='json')
    sparql.setQuery("""
    PREFIX dbpj: <http://ja.dbpedia.org/resource/>
    PREFIX dbp-owl: <http://dbpedia.org/ontology/>

    SELECT ?abstract
    WHERE
    {
    dbpj:"""+word+""" dbp-owl:abstract ?abstract.
    }
    """)
    results = sparql.query().convert()

    if results['results']['bindings']==[]:
        return ''
    else:
        return results['results']['bindings'][0]['abstract']['value']

search_wiki_abstract("応力")

def download_image(word,n):
    import requests
    from PIL import Image, ImageFilter
    from io import BytesIO
    import os
    subscription_key = '###'
    assert subscription_key

    search_url = "https://api.cognitive.microsoft.com/bing/v7.0/images/search"
    search_term = word

    headers = {"Ocp-Apim-Subscription-Key" : subscription_key}
    params  = {"q": search_term, "license": "public", "imageType": "photo"}
    response = requests.get(search_url, headers=headers, params=params)
    response.raise_for_status()
    search_results = response.json()
    thumbnail_urls = [img["thumbnailUrl"] for img in search_results["value"][:n]]

    image_list=[]
    for i in range(n):
        image_data = requests.get(thumbnail_urls[i])
        image_data.raise_for_status()
        image = Image.open(BytesIO(image_data.content))
        filename='sample_{}_image{}.jpg'.format(word,i)
        image_list.append(os.path.abspath(filename))
        image.save(filename, 'JPEG', quality=100, optimize=True)
    return image_list

